//Cluster Demo on AOS with network support
//Sums an array

#include <mega32.h>
#include <delay.h>
#include <stdio.h>

#include "aos.h"  
#include "user_tasks.h"
#include "aos_core.c" 
#include "aos_task.c"                   
#include "aos_semaphore.c"	//omit if no semaphores or mail used
//#include "aos_mbox.c"		//omit if no mailboxes     		
//#include "aos_uart.c"		//omit if you don't need UART
#include "aos_network.c"

#define PID (UBYTE)3

void task1(void)
{
    //For status LEDs
    PORTA = 0xff;
    DDRA = 0xff;
    
    //USART Init  
    UCSRB = 0x18;
    UBRRL = 103;        
	  
    net_init();
    PORTA = 0x00;
    delay_ms(100);
    
    //program
    {
        if (PID != (UBYTE)0)                    //Nodes 1, 2, 3
        {
            unsigned char i = 0, sum = 0, ret;
            unsigned char *get, buf[1];
            putsf("Receiving\r");
            while (i < 16)
            {
                receive_wait();
                ret = net_recv(0, 0, 1, buf);
                if (ret != 0)
                {
                    i += ret;
                    sum += buf[0];
                    printf("bytes rx: %d, Got %d, sum now %d\r\n", ret, buf[0], sum);
                }
            }
            buf[0] = sum;
            printf("Sending result %d to addr %d tag %d\r", buf[0], 0, PID);
            net_send(0, PID, 1, buf);
        }
        else                                    //Node 0
        {
            unsigned char i, j, stop = 0, buf[] = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15}, ret;
            PORTA = 0xff;
            putsf("Sending data\r");
            for (i = 0; i < 16; i++)
                printf("%d ", buf[i]);
            putsf("\r");
            net_send(1, 0, 16, buf);
            net_send(2, 0, 16, buf);
            net_send(3, 0, 16, buf);
            PORTA = 0x0f;
            receive_wait();
            putsf("Got first result\r");
            receive_wait();
            putsf("Got second result\r");
            receive_wait();
            putsf("Got third result\r");
            PORTA = 0xf0;
            while(stop < 3)
            {
                ret = net_recv(1, 1, 1, buf);
                stop += ret;
                ret = net_recv(2, 2, 1, buf+1);
                stop += ret;
                ret = net_recv(3, 3, 1, buf+2);
                stop += ret;
            }
            PORTA = ~(buf[0]);
            printf("Result 1=%d\r\n", buf[0]);
            printf("Result 2=%d\r\n", buf[1]);
            printf("Result 3=%d\r\n", buf[2]);
        }
    }
    
	while (1)
	{
	}
}