/********************************
Defines the user task names and
task stacks.

Include order:
#include <mega32.h>   
#include <stdio.h>                                           
#include "aos.h" 
#include "user_tasks.h"
#include "aos_core.c" 
#include "aos_task.c"
#include "semaphore.c"
#include "mbox.c"
********************************/   

//PIDs should be mapped to ports on the network switch as follows:
//Port      PID
//PORTA     0
//PORTB     1
//PORTC     2
//PORTD     3
//#define PID   (UBYTE)0

//Need this to identify the first task to aos_core.c
#define AOS_FIRST_TASK_NAME task1
#define AOS_FIRST_TASK_DSTACK_NAME data_stack1 
#define AOS_FIRST_TASK_HSTACK_NAME hw_stack1 
#define AOS_FIRST_TASK_PRIO     50 //priority

//user defined names for tasks
//The task names will be used during calls
//to aos_task_create   
//NOTE that the creation of task1 is done in aos_core.c
void task1(void);     
//void task2(void);
//void task3(void);
//void task4(void);    

//stack definitions for each task
//The stack names will be used during calls
//to aos_task_create
UBYTE data_stack1[AOS_TASK_DSTK_SIZE], hw_stack1[AOS_TASK_HSTK_SIZE];		/* Stacks for task1 */
//UBYTE data_stack2[AOS_TASK_DSTK_SIZE], hw_stack2[AOS_TASK_HSTK_SIZE];		/* Stacks for task2 */
//UBYTE data_stack3[AOS_TASK_DSTK_SIZE], hw_stack3[AOS_TASK_HSTK_SIZE];		/* Stacks for task3 */
//UBYTE data_stack4[AOS_TASK_DSTK_SIZE], hw_stack4[AOS_TASK_HSTK_SIZE];		/* Stacks for task4 */

